unit GridForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs, Globals,
  StdCtrls, Contnrs, ComCtrls, Menus, ToolWin, ImgList, graphics,
  PalmDatabase, DocFile, DatabaseInfo, IniFiles, ShellApi, RCREdit, OptionsForm;

type
  ROptions = record
    Font: TFont;
    UseOtherProg: Boolean;
    StatusbarVisible: Boolean;
    ToolbarAlign: byte;
    Wrap: Boolean;

    // ListCount:Integer;
    // List:TStringList;
  end;

  TfGrid = class(TForm)
    ToolBar1: TToolBar;
    RichEdit1: TRichEdit;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ImageList1: TImageList;
    sbStatus: TStatusBar;
    SaveDialog1: TSaveDialog;
    ToolButton6: TToolButton;
    FontDialog1: TFontDialog;
    ToolButton7: TToolButton;
    PopupMenu1: TPopupMenu;
    pCopy: TMenuItem;
    ToolButton8: TToolButton;
    PopupMenu2: TPopupMenu;
    Top1: TMenuItem;
    Left1: TMenuItem;
    Bottom1: TMenuItem;
    Right1: TMenuItem;
    CopyAlltoClipboard1: TMenuItem;
    Saveastext1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    View1: TMenuItem;
    StatusBar1: TMenuItem;
    N2: TMenuItem;
    pdbfileinfo1: TMenuItem;
    Font1: TMenuItem;
    Wrap1: TMenuItem;
    ToolButton9: TToolButton;
    Refresh1: TMenuItem;
    ToolButton10: TToolButton;
    Options1: TMenuItem;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton11: TToolButton;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure pCopyClick(Sender: TObject);
    procedure RichEdit1SelectionChange(Sender: TObject);
    procedure sbStatusDblClick(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure RichEdit1Change(Sender: TObject);
    procedure Top1Click(Sender: TObject);
    procedure Left1Click(Sender: TObject);
    procedure Bottom1Click(Sender: TObject);
    procedure Right1Click(Sender: TObject);
    procedure CopyAlltoClipboard1Click(Sender: TObject);
    procedure StatusBar1Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure Refresh1Click(Sender: TObject);
    procedure Wrap1Click(Sender: TObject);
    procedure sbStatusDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
      const Rect: TRect);
    procedure ToolButton10Click(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormHide(Sender: TObject);
  private
    { Private declarations }
    FileToLoad: string;
    INIFileName: string;
    opt: ROptions;
  public
    { Public declarations }
    procedure OpenAndDisplayDoc(FileName: string);
    function SearchText(SearchString: PAnsiChar;
      SearchParameter: Integer): Integer;
    procedure LoadOptions;
    procedure SaveOptions;
  end;

function CreateGrid(ParentWin: THandle; FileToLoad: string): THandle;
procedure FreeGrid(GridWin: THandle);
function SearchText(ParentWin: THandle; SearchString: PAnsiChar;
  SearchParameter: Integer): Integer;

var
  OpenGridsList: TObjectList;

implementation

uses AboutForm;

var
  Doc: TPalmPDB;

function ViewDBHeader(FileToLoad: string): AnsiString;

  function StringToBoolean(str: AnsiString): Boolean;
  begin
    if CompareText(UpperCase(str), 'TRUE') = 0 then
      Result := True
    else
      Result := False;
  end;
  function BooleanToString(b: Boolean): AnsiString;
  begin
    if b then
      Result := 'True'
    else
      Result := 'False';
  end;

Begin
  try
    Doc := TPalmPDB.Create(FileToLoad, doExisting);
    Result := Result + Chr(10) + 'PDB Header Info';
    Result := Result + Chr(10) +
      '================================================';
    Result := Result + Chr(10) + 'Name:           ' + Doc.DBHeader.Name;
    Result := Result + Chr(10) + 'DBFileSize:     ' + IntToStr(Doc.DBFileSize)
      + ' bytes';
    Result := Result + Chr(10) + 'Flags ';
    Result := Result + Chr(10) + 'ReadOnly:       ' + BooleanToString
      (Doc.DBHeader.ReadOnly);
    Result := Result + Chr(10) + 'Dirty:          ' + BooleanToString
      (Doc.DBHeader.Dirty);
    Result := Result + Chr(10) + 'Backup:         ' + BooleanToString
      (Doc.DBHeader.Backup);
    Result := Result + Chr(10) + 'Overwrite:      ' + BooleanToString
      (Doc.DBHeader.Overwrite);
    Result := Result + Chr(10) + 'ForceReset:     ' + BooleanToString
      (Doc.DBHeader.ForceReset);
    Result := Result + Chr(10) + 'NoBeam:         ' + BooleanToString
      (Doc.DBHeader.NoBeam);

    Result := Result + Chr(10) + 'Version:        ' + IntToStr
      (Doc.DBHeader.Version);
    Result := Result + Chr(10) + 'Date Created:   ' + DateTimeToStr
      (Doc.DBHeader.Created);
    Result := Result + Chr(10) + 'Date Modified:  ' + DateTimeToStr
      (Doc.DBHeader.Modified);
    Result := Result + Chr(10) + 'Date BackedUp:  ' + DateTimeToStr
      (Doc.DBHeader.BackedUp);
    Result := Result + Chr(10) + 'Modification:   ' + IntToStr
      (Doc.DBHeader.Modification);
    Result := Result + Chr(10) + 'AppInfoArea:    ' + IntToStr
      (Doc.DBHeader.AppInfoArea);
    Result := Result + Chr(10) + 'SortInfoArea:   ' + IntToStr
      (Doc.DBHeader.SortInfoArea);
    Result := Result + Chr(10) + 'DBType:         ' + Doc.DBHeader.DBType;
    Result := Result + Chr(10) + 'CreatorID:      ' + Doc.DBHeader.CreatorID;
    Result := Result + Chr(10) + 'IDSeed:         ' + IntToStr
      (Doc.DBHeader.IDSeed);
    Result := Result + Chr(10) + 'NextRecordList: ' + IntToStr
      (Doc.DBHeader.NextRecordList);
    Result := Result + Chr(10) + 'NumRecords:     ' + IntToStr
      (Doc.DBHeader.NumRecords);
  except
    Result := Result + Chr(10) + '  Palm OS DOC  ' + Chr(10)
      + ' Not Palm OS DOC file ';
    // Doc.Free;
  end;
  Doc.Free;
end;

/// ///////// CREATE GRID /////////////////////
function CreateGrid(ParentWin: THandle; FileToLoad: string): THandle;
var
  LfGrid: TfGrid;
  /// /////////////
  TempFile: TPalmPDB;
  Libr: TIniFile;
  app: string;
  hwnd: THandle;
  SecurityInfo: PSecurityAttributes;
  StartupInfo: TStartupInfo;
  ProcessInformation: TProcessInformation;
  /// //////////////
begin
  try
    LfGrid := TfGrid.CreateParented(ParentWin);
    LfGrid.Hide;
    LfGrid.FileToLoad := FileToLoad;
    LfGrid.Show;
    LfGrid.OpenAndDisplayDoc(FileToLoad);
    LfGrid.ToolButton2.Enabled := True;
  except //   
    /// ////////////////////////
    if LfGrid.opt.UseOtherProg then //   
    begin
      //   
      try
        TempFile := TPalmPDB.Create(FileToLoad, TDatabaseOpenMode(doExisting));
        Libr := TIniFile.Create(LfGrid.INIFileName);
        app := (Libr.ReadString('Files',
            TempFile.DBHeader.DBType + TempFile.DBHeader.CreatorID, ''));
        Libr.Free;
        LfGrid.RichEdit1.Text := '     ' + FileToLoad + Chr
          (10) + '      ';
        if UpperCase(app) <> '' then
          if FileExists(app) then
          begin
            app := app + ' "' + FileToLoad + '"';
            // hwnd:=Application.Handle;
            {
              /////////////////////////////////////
              SecurityInfo.lpSecurityDescriptor:=0;
              GetStartupInfo(StartupInfo);
              with StartupInfo do
              begin
              wShowWindow := SW_SHOWNORMAL; //  
              dwFlags := STARTF_USESHOWWINDOW or STARTF_USESTDHANDLES;
              end;
              Win32Check(CreateProcess(
              PAnsiChar(App),	// pointer to name of executable module
              0,	// pointer to command line AnsiString
              SecurityInfo,	// pointer to process security attributes   !!!!!!!
              0,	// pointer to thread security attributes
              FALSE,	// handle inheritance flag                        !!!!!!!!!!
              NORMAL_PRIORITY_CLASS,	// creation flags              !!!!!!!!!!!
              0,	// pointer to new environment block
              0,	// pointer to current directory name
              StartupInfo,	// pointer to STARTUPINFO
              ProcessInformation	// pointer to PROCESS_INFORMATION
              ));
              //     
              //  WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
              Result :=ProcessInformation.hProcess;
              Win32Check(CloseHandle(ProcessInformation.hProcess));
              ////////////////////////////////////
            }
            Result := WinExec(PAnsiChar(app), SW_SHOWDEFAULT);
            LfGrid.RichEdit1.Text := '  ' + FileToLoad + Chr(10)
              + '   ' + app;
            if (Result < 32) then
            begin
              LfGrid.RichEdit1.Text :=
                '     ' + FileToLoad + Chr(10)
                + '     ' + app;
            end
          end
          else //   
            if UpperCase(app) = 'INTERNAL' then
          begin

          end
          else
          begin
            LfGrid.RichEdit1.Text := '     ' + FileToLoad + Chr
              (10) + '     ' + app;
          end;

      except //  
        LfGrid.RichEdit1.Text :=
          '          ' +
          FileToLoad + Chr(10) + '     ' + app;
      end;
      LfGrid.RichEdit1.Text := LfGrid.RichEdit1.Text + Chr(10)
        + ' ' + ViewDBHeader(FileToLoad);
    end
    else //    
    /// //////////////////////////////////////////////////////

    begin
      LfGrid.RichEdit1.Text := '     ' + FileToLoad + Chr(10)
        + '      ';
      LfGrid.RichEdit1.Text := LfGrid.RichEdit1.Text + Chr(10)
        + ' ' + ViewDBHeader(FileToLoad);
    end; // end else

  end; // end try
  OpenGridsList.Add(LfGrid);
  Result := LfGrid.Handle;
end;

procedure FreeGrid(GridWin: THandle);
var
  i: Integer;
begin
  for i := 0 to OpenGridsList.Count - 1 do
  begin
    if TfGrid(OpenGridsList[i]).Handle = GridWin then
    begin
      // TfGrid(OpenGridsList[i]).SaveOptions;
      OpenGridsList.Remove(OpenGridsList[i]);
      Break;
    end;
  end;
end;

function SearchText(ParentWin: THandle; SearchString: PAnsiChar;
  SearchParameter: Integer): Integer;
var
  i: Integer;
begin
  for i := 0 to OpenGridsList.Count - 1 do
  begin
    if TfGrid(OpenGridsList[i]).Handle = ParentWin then
    begin
      Result := TfGrid(OpenGridsList[i]).SearchText(SearchString,
        SearchParameter);
      Break;
    end;
  end;

end;
{$R *.dfm}
{ ======================== TfGrid ========================== }

function TfGrid.SearchText(SearchString: PAnsiChar;
  SearchParameter: Integer): Integer;
var
  FoundAt: LongInt;
  StartPos, ToEnd: Integer;
  ST: TSearchTypes;
begin
  // ok
  {
    lcs_findfirst=1;
    lcs_matchcase=2;
    lcs_wholewords=4;
    lcs_backwards=8;
  }
  ST := [];
  with RichEdit1 do
  begin
    StartPos := 0;
    ToEnd := Length(Text) - StartPos;
    if (SearchParameter and $1) = 1 then
      StartPos := 0
    else if SelLength <> 0 then
      StartPos := SelStart + SelLength;
    if (SearchParameter and $2) = 1 then
      ST := ST + [stMatchCase];
    if (SearchParameter and $4) = 1 then
      ST := ST + [stWholeWord];
    // if (SearchParameter and $8) =1 then StartPos := Length(Text);
    FoundAt := FindText(SearchString, StartPos, ToEnd, ST);
    if FoundAt <> -1 then
    begin
      // SetFocus;
      SelStart := FoundAt;
      SelLength := Length(SearchString);
      Result := 0;
    end
    else
    begin
      Result := 1;
      // ShowMessage('  ');
    end
  end;

end;

procedure TfGrid.FormKeyPress(Sender: TObject; var Key: Char);
begin
  {
    if (Key = 'w') or (Key = 'W') then
    begin
    if RichEdit1.WordWrap then RichEdit1.WordWrap:=False
    else RichEdit1.WordWrap:=True ;
    if RichEdit1.WordWrap then RichEdit1.ScrollBars:=ssBoth
    else RichEdit1.ScrollBars:=ssVertical ;
    RichEdit1.Refresh;
    end;
  }
  // PostMessage(ParentWindow, WM_CLOSE, 0, 0)
  // else
  // PostMessage(ParentWindow, WM_SETTEXT, 0, ord(VK_DOWN));

end;

procedure TfGrid.OpenAndDisplayDoc(FileName: string);
var
  Doc: TDocFile;
  i: Integer;
begin
  begin
    // Create the doc object
    try
      Doc := TDocFile.Create(FileName);
    except
      on E: Exception do
      begin
        ShowMessage(Doc.DBHeader.DBType + ' ' + Doc.DBHeader.CreatorID + ' ' +
            E.Message);
        Doc.Free;
        Doc := nil;
        exit;
      end;
    end;
    // Change the title bar and status bar
    Caption := TITLE_TEXT + ' - ' + Doc.DBHeader.Name;
    sbStatus.Panels[0].Text := FileName;
    // Display the document
    Self.RichEdit1.Text := Doc.GetDocument;
    {
      if Doc.BookmarkList.Count >1 then
      for i:=0 to Doc.BookmarkList.Count -1 do
      Self.ComboBox1.Items[i]:= Doc.BookmarkList.Items[i];
    }
    Self.RichEdit1.SetFocus;
    Doc.Free;
  end;
  {
    except
    raise EInvalidDocFile.Create('Not a valid Doc file');
    end;
  }
end;

procedure TfGrid.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveOptions;
  {
    if Doc <> nil then
    begin
    Doc.Free;
    Doc := nil;
    end;
  }
  // PostMessage(ParentWindow, WM_CLOSE, 0, 0);
end;

procedure TfGrid.ToolButton1Click(Sender: TObject);
begin
  RichEdit1.PlainText := True;
  SaveDialog1.InitialDir := ExtractFilePath(FileToLoad);
  SaveDialog1.FileName := ChangeFileExt(FileToLoad, '.txt');
  if SaveDialog1.Execute then
    RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);

  RichEdit1.PlainText := False;
end;

procedure TfGrid.ToolButton3Click(Sender: TObject);
begin
  ShowInfoForm;
end;

procedure TfGrid.ToolButton2Click(Sender: TObject);
var
  frmDatabaseInfo: TfrmDatabaseInfo;
  Doc: TDocFile;
begin
  try
    Doc := TDocFile.Create(FileToLoad);
  except
    on E: Exception do
    begin
      // ShowMessage(Doc.DBHeader.DBType + ' '+Doc.DBHeader.CreatorID);
      ShowMessage(E.Message);
      FreeAndNil(Doc);
      exit;
    end;
  end;
  frmDatabaseInfo := TfrmDatabaseInfo.Create(Application);
  try
    frmDatabaseInfo.ARefresh(Doc, False); //  
    frmDatabaseInfo.ShowModal;
    // In case they changed the name
    // Caption := TITLE_TEXT + ' - ' + Doc.DBHeader.Name;
  finally
    frmDatabaseInfo.Free;
    Doc.Free;
  end;
end;

procedure TfGrid.ToolButton6Click(Sender: TObject);
begin
  if FontDialog1.Execute then
    RichEdit1.Font := FontDialog1.Font;
  opt.Font := RichEdit1.Font;
end;

procedure TfGrid.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = Ord('w')) OR (Key = Ord('W')) then
  begin
    ToolButton8.OnClick(Self);
  end;

  if Key = Ord(VK_SPACE) then
    PostMessage(RichEdit1.Handle, WM_KEYDOWN, Ord(VK_NEXT), 0)
  else
    PostMessage(ParentWindow, WM_KEYDOWN, Key, 0);
end;

procedure TfGrid.FormCreate(Sender: TObject);
var
  dllpath: array [0 .. 512] of Char;
begin
  // Default options
  opt.UseOtherProg := False;
  opt.Font := RichEdit1.Font;
  opt.StatusbarVisible := False;
  opt.ToolbarAlign := 0;
  opt.Wrap := False;

  //  
  FillChar(dllpath, sizeof(dllpath), #0);
  GetModuleFileName(hInstance, dllpath, sizeof(dllpath));
  INIFileName := ChangeFileExt(dllpath, '.ini');

  LoadOptions;

  RichEdit1.Font.Name := opt.Font.Name;
  RichEdit1.Font.Size := opt.Font.Size;
  // ToolBar1.Visible := opt.ToolbarVisible;
  // ToolBar2.Checked := opt.ToolbarVisible;
  StatusBar1.Checked := opt.StatusbarVisible;
  sbStatus.Visible := opt.StatusbarVisible;
  ToolButton8.Down := opt.Wrap;
  Wrap1.Checked := opt.Wrap;
  RichEdit1.WordWrap := opt.Wrap;
  ToolButton9.Down := opt.StatusbarVisible;
  // ToolBar1.Align := opt.ToolbarAlign;

end;

// -------------------------------------Load Save Options -------------------------
function StringToBoolean(str: AnsiString): Boolean;
begin

  if CompareText(UpperCase(str), 'TRUE') = 0 then
    Result := True
  else
    Result := False;
end;

function BooleanToString(b: Boolean): AnsiString;
begin
  if b then
    Result := 'True'
  else
    Result := 'False';
end;

procedure TfGrid.LoadOptions;
var
  Libr: TIniFile;
begin
  if not FileExists(INIFileName) then
  begin
    // ShowMessage(INIFileName);   //DDDDDDDDDDDDDDDDDDDDDDDDDDD
    ShowMessage('  "' + INIFileName + '"  .  .');
    SaveOptions;
    // abort;
  end;

  Libr := TIniFile.Create(INIFileName);

  opt.UseOtherProg := StringToBoolean(Libr.ReadString('Options',
      'UseOtherProg', 'False'));
  opt.Font.Name := Libr.ReadString('Options', 'FontName', opt.Font.Name);
  opt.Font.Size := Libr.ReadInteger('Options', 'FontSize', opt.Font.Size);
  opt.StatusbarVisible := StringToBoolean(Libr.ReadString('Options',
      'StatusbarVisible', 'False'));
  opt.Wrap := StringToBoolean(Libr.ReadString('Options', 'Wrap', 'False'));
  opt.ToolbarAlign := Libr.ReadInteger('Options', 'ToolbarAlign', 0);

  {
    opt.AutoLoad:=StrToInt(Libr.ReadString('Options', 'AutoLoad', '0'));
    opt.HotKeyEnableb:=StringToBoolean(Libr.ReadString('Options', 'HotKeyEnableb', 'False'));
    opt.HotKeyCode1:=StrToInt(Libr.ReadString('Options', 'HotKeyCode1', IntToStr(HotKeyCode1_def)));
    opt.HotKeyMod1:=StrToInt(Libr.ReadString('Options', 'HotKeyMod1', IntToStr(HotKeyMod_def)));
    opt.HotKeyCode2:=StrToInt(Libr.ReadString('Options', 'HotKeyCode2', IntToStr(HotKeyCode2_def)));
    opt.HotKeyMod2:=StrToInt(Libr.ReadString('Options', 'HotKeyMod2', IntToStr(HotKeyMod_def)));
  }

  // -------- DEBUG___
  // opt.HeaderFont.Name:=Libr.ReadString('Options', 'HeaderFontName', DefaultFontName);
  // opt.HeaderFont.Size:= StrToInt(Libr.ReadString('Options', 'HeaderFontSize', IntToStr(DefaultFontSize)));
  {
    Left:=StrToInt(Libr.ReadString('Interface', 'Left', IntToStr(Left)));
    Top:=StrToInt(Libr.ReadString('Interface', 'Top', IntToStr(Top)));
    Width:=StrToInt(Libr.ReadString('Interface', 'Width', IntToStr(Width)));
    Height:=StrToInt(Libr.ReadString('Interface', 'Height', IntToStr(Height)));
  }
  Libr.Free;
end;

procedure TfGrid.SaveOptions;
var
  Libr: TIniFile;
begin
  Libr := TIniFile.Create(INIFileName);
  try
    try
      Libr.WriteString('Options', 'UseOtherProg',
        BooleanToString(opt.UseOtherProg));
      Libr.WriteString('Files', 'TEXTREAD', 'INTERNAL');
      Libr.WriteString('Options', 'FontSize', IntToStr(opt.Font.Size));
      Libr.WriteString('Options', 'FontName', opt.Font.Name);
      Libr.WriteString('Options', 'StatusbarVisible',
        BooleanToString(opt.StatusbarVisible));
      Libr.WriteString('Options', 'Wrap', BooleanToString(opt.Wrap));
      Libr.WriteString('Options', 'ToolbarAlign', IntToStr(opt.ToolbarAlign));
      {
        Libr.WriteString('Options', 'HotKeyEnableb', BooleanToString(opt.HotKeyEnableb));
        Libr.WriteString('Options', 'HotKeyCode1', IntToStr(opt.HotKeyCode1));
        Libr.WriteString('Options', 'HotKeyMod1', IntToStr(opt.HotKeyMod1));
        Libr.WriteString('Options', 'HotKeyCode2', IntToStr(opt.HotKeyCode2));
        Libr.WriteString('Options', 'HotKeyMod2', IntToStr(opt.HotKeyMod2));
        }
      // Libr.WriteString('Interface', 'WindowState', 'Normal' );
      {
        Libr.WriteString('Interface', 'Left', IntToStr(Left) );
        Libr.WriteString('Interface', 'Top', IntToStr(Top) );
        Libr.WriteString('Interface', 'Width', IntToStr(Width) );
        Libr.WriteString('Interface', 'Height', IntToStr(Height) );
        }
      Libr.UpdateFile;
    except
      ShowMessage('   ');
      Application.Terminate;
    end;
  finally
    Libr.Free;
  end
end;

procedure TfGrid.FormShow(Sender: TObject);
begin
  {
    RichEdit1.Font.Name:=opt.Font.Name;
    RichEdit1.Font.Size:=opt.Font.Size;
    ToolBar1.Visible := opt.ToolbarVisible;
    StatusBar1.Visible := opt.StatusbarVisible;
    ToolButton8.Down:= opt.Wrap;
    }
end;

procedure TfGrid.FormPaint(Sender: TObject);
begin
  // sbStatus.Panels[1].Text:='  '+ IntToStr(RichEdit1.SelStart)+'  '+ IntToStr(RichEdit1.Lines.Count);
end;

procedure TfGrid.pCopyClick(Sender: TObject);
begin
  // copy
  RichEdit1.CopyToClipboard;
end;

procedure TfGrid.RichEdit1SelectionChange(Sender: TObject);
var
  Y: LongInt;
begin
  Y := RichEdit1.Perform(EM_LINEFROMCHAR, RichEdit1.SelStart, 0);
  inc(Y);
  sbStatus.Panels[1].Text := '  ' + IntToStr(Y) + '  ' + IntToStr
    (RichEdit1.Lines.Count + 1);
end;

procedure TfGrid.sbStatusDblClick(Sender: TObject);
var
  a: string;
begin
  a := '1';
  if InputQuery('Input LineNumber', 'LineNumber', a) then
    RichEdit1.SelStart := RichEdit1.Perform(EM_LINEINDEX, StrToInt(a) - 1, 0);

end;

procedure TfGrid.CheckBox1Click(Sender: TObject);
var
  re: TRCRichEdit;
begin
  {
    if CheckBox1.Checked then
    begin
    re:=TRCRichEdit.CreateParented(Self.Handle);
    re.Text:=RichEdit1.Text;
    re.Col:=30;
    Re.Show;
    RichEdit1.Text:=re.Text;
    re.free;
    end;
  }
end;

procedure TfGrid.ToolButton8Click(Sender: TObject);
begin
  RichEdit1.WordWrap := not RichEdit1.WordWrap;
  ToolButton8.Down := RichEdit1.WordWrap;

  if not RichEdit1.WordWrap then
    RichEdit1.ScrollBars := ssBoth
  else
    RichEdit1.ScrollBars := ssVertical;
  RichEdit1.Refresh;
  Wrap1.Checked := RichEdit1.WordWrap;
end;

procedure TfGrid.RichEdit1Change(Sender: TObject);
var
  Y: LongInt;
begin
  Y := RichEdit1.Perform(EM_LINEFROMCHAR, RichEdit1.SelStart, 0);
  inc(Y);
  sbStatus.Panels[1].Text := '  ' + IntToStr(Y) + '  ' + IntToStr
    (RichEdit1.Lines.Count + 1);
end;

procedure TfGrid.Top1Click(Sender: TObject);
begin
  ToolBar1.Align := alTop;
  PopupMenu2.Items[3].Checked := False;
  PopupMenu2.Items[2].Checked := False;
  PopupMenu2.Items[1].Checked := False;
  PopupMenu2.Items[0].Checked := True;
end;

procedure TfGrid.Left1Click(Sender: TObject);
begin
  ToolBar1.Align := alLeft;
  PopupMenu2.Items[3].Checked := False;
  PopupMenu2.Items[2].Checked := False;
  PopupMenu2.Items[0].Checked := False;
  PopupMenu2.Items[1].Checked := True;
end;

procedure TfGrid.Bottom1Click(Sender: TObject);
begin
  ToolBar1.Align := alBottom;
  PopupMenu2.Items[3].Checked := False;
  PopupMenu2.Items[0].Checked := False;
  PopupMenu2.Items[1].Checked := False;
  PopupMenu2.Items[2].Checked := True;
end;

procedure TfGrid.Right1Click(Sender: TObject);
begin
  ToolBar1.Align := alRight;
  PopupMenu2.Items[0].Checked := False;
  PopupMenu2.Items[2].Checked := False;
  PopupMenu2.Items[1].Checked := False;
  PopupMenu2.Items[3].Checked := True;
end;

procedure TfGrid.CopyAlltoClipboard1Click(Sender: TObject);
begin
  RichEdit1.SelectAll;
end;

procedure TfGrid.StatusBar1Click(Sender: TObject);
begin
  StatusBar1.Checked := not StatusBar1.Checked;
  ToolButton9.Down := StatusBar1.Checked; // PopupMenu1.Items[5].Items[1].checked;
  ToolButton9Click(Self);
  RichEdit1.Refresh;
end;

procedure TfGrid.ToolButton9Click(Sender: TObject);
begin
  sbStatus.Visible := ToolButton9.Down;
  StatusBar1.Checked := ToolButton9.Down;
  RichEdit1.Update;
  RichEdit1.Refresh;
end;

procedure TfGrid.Refresh1Click(Sender: TObject);
begin
  RichEdit1.Refresh;
end;

procedure TfGrid.Wrap1Click(Sender: TObject);
begin
  ToolButton8Click(Self);
  Wrap1.Checked := RichEdit1.WordWrap;
  ToolButton8.Down := RichEdit1.WordWrap; // PopupMenu1.Items[5].Items[3].checked;
end;

procedure TfGrid.sbStatusDrawPanel(StatusBar: TStatusBar; Panel: TStatusPanel;
  const Rect: TRect);
begin
  RichEdit1.Refresh;
end;

procedure TfGrid.ToolButton10Click(Sender: TObject);
// var  frmOptions:TfrmOptions;
begin
  {
    frmOptions:=TfrmOptions.Create(nil);
    frmOptions.ShowModal;
  }
  ShellExecute(Application.Handle, 'open', PChar(INIFileName), nil, nil,
    SW_SHOWNORMAL);
end;

procedure TfGrid.Options1Click(Sender: TObject);
begin
  ToolButton10Click(Self);
end;

procedure TfGrid.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  opt.Font.Name := RichEdit1.Font.Name;
  opt.Font.Size := RichEdit1.Font.Size;
  // opt.ToolbarVisible:=ToolBar1.Visible ;
  // opt.ToolbarVisible := ToolBar2.Checked;
  // StatusBar1.Checked := opt.StatusbarVisible;
  opt.StatusbarVisible := sbStatus.Visible;
  // ToolButton8.Down:= opt.Wrap;
  opt.Wrap := Wrap1.Checked;
  // opt.ToolbarAlign := ToolBar1.align;
end;

procedure TfGrid.FormHide(Sender: TObject);
var
  bbb: Boolean;
begin
  FormCloseQuery(Self, bbb);
  // SaveOptions;
end;

initialization

OpenGridsList := TObjectList.Create;
OpenGridsList.OwnsObjects := True;

finalization

OpenGridsList.Free;

end.
